//
//	$Date: 2001/06/16 10:55:34 $
//	$Revision: 1.3 $
//
#include <PalmOS.h>
#include <SonyCLIE.h>
#include "palmwiki.h"
#include "pwprefs.h"

Boolean BackToPrevApp();

typedef Boolean SysHandleEventTrapFunc(EventType* event);

// This function must put at the top of this file.
Boolean SysHandleEventHack(EventType *event)
{
	SysHandleEventTrapFunc *trapfunc;

	// Get the original trap address of EvtGetEvent and call it.
	FtrGet(PWCREATOR,1001,(UInt32*)(&trapfunc));

	if(event->eType == keyDownEvent &&
	   (event->data.keyDown.chr == vchrJogBack ||
	    event->data.keyDown.chr == prevFieldChr)){
		if(BackToPrevApp()){
			event->eType = nilEvent;
			return true;
		}
	}

	return (*trapfunc)(event);
}

#ifdef USEGETEVENT
typedef void EvtGetEventTrapFunc(EventType*, Int32);

// This function must put at the top of this file.
void EvtGetEventHack(EventType *event, Int32 timeout)
{
	EvtGetEventTrapFunc *trapfunc;

	// Get the original trap address of EvtGetEvent and call it.
	FtrGet(PWCREATOR,1001,(UInt32*)(&trapfunc));

	(*trapfunc)(event,timeout);

	if(event->eType == keyDownEvent &&
	   event->data.keyDown.chr == vchrJogBack){
		if(BackToPrevApp()) event->eType = nilEvent;
	}
}
#endif

Boolean BackToPrevApp()
{
	GoToParamsType *cmdPBP;
	WikiPref pref;
	Link *link;

	DmOpenRef db;
	LocalID id;
	UInt16 cardno;
	UInt32 type,creator;
	Boolean backenable = false;

	// Go back to prev app when memo DB is currently open or
	// PalmWiki-related apps are running

	// Check all the open database and see if memo is currently open
	db = DmNextOpenDatabase(NULL);
	while(db){
		DmOpenDatabaseInfo(db,&id,
			NULL,NULL,&cardno,NULL);
		DmDatabaseInfo(cardno,id,
			NULL,NULL,NULL,
			NULL,NULL,NULL,
			NULL,NULL,NULL,
			&type,&creator);
		if(type == 'DATA' && creator == 'memo'){
			backenable = true;
			break;
		}
		if(type == 'appl' && (
			creator == 'memo' || // standard memo app
			creator == 'SNMM' || // Snap!Memo
			creator == 'QPKT'    // Q-Pocket
			)){
			backenable = true;
			break;
		}
		db = DmNextOpenDatabase(db);
	}
	if(! backenable) return false;

	GetWikiPreferences(&pref,true);

	if(pref.linkstackindex <= 0) return false;
	pref.linkstackindex--;
	PrefSetAppPreferences(PWCREATOR,0,1,&pref,sizeof(WikiPref),true);

	link = &(pref.linkstack[pref.linkstackindex]);
	if(link->recordno == 0xffff){
		// If no record was found, just jump back to the previous application.
		SysUIAppSwitch(link->appcardno,link->appid,sysAppLaunchCmdNormalLaunch,NULL);
	}
	else {
		// Jump to a specific record.
		cmdPBP = (GoToParamsType*)MemPtrNew(sizeof(GoToParamsType));
		cmdPBP->searchStrLen = 0;
		cmdPBP->dbCardNo = link->datacardno;
		cmdPBP->dbID = link->dataid;
		cmdPBP->recordNum = link->recordno;
		cmdPBP->matchPos = 0;
		cmdPBP->matchFieldNum = 0; 
		cmdPBP->matchCustom = 0;
		MemPtrSetOwner((MemPtr)cmdPBP,0);
		SysUIAppSwitch(link->appcardno,link->appid,sysAppLaunchCmdGoTo,(MemPtr)cmdPBP);
	}
	return true;
}





